<?php defined('BASEPATH') OR exit('No direct script access allowed'); 
if (isset($_SERVER['HTTP_ORIGIN'])) {
	header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
	header('Access-Control-Allow-Credentials: true');
	header('Access-Control-Max-Age: 86400'); 
}
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

	if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
		header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
		exit(0);
}
class ErpController extends CI_Controller
{
	
	protected $user_id;
	protected $role;
	protected $designation;
	protected $objCurrentEmployee;

    public function __construct() {
        parent::__construct();
		$this->load->library('session');
		$this->load->model('ErpModel');
		$this->load->model('EmployeeModel');
		$this->load->model('UserRoleModel');
		$this->load->model('PurchaseOrderModel');
		$this->load->model('BuyerModel');
		$this->load->model('StyleModel');
		$this->getLoggedInUser();
    }
	
	public function getRequiredInitialData(){
		$data['purchase_orders'] = $this->PurchaseOrderModel->getPurchaseOrders($this->objCurrentEmployee->company_id);
		$data['buyers'] = $this->BuyerModel->getBuyers();
		$data['styles'] = $this->StyleModel->getStyles($this->objCurrentEmployee->company_id);
		$data['erp_statuses'] = $this->ErpModel->getErpStatuses();
		echo json_encode($data);
	}
	
	public function getErpList(){
		if($this->role != UserRoleModel::ADMIN_ID){
            $erp = $this->ErpModel->getErpList($this->objCurrentEmployee->company_id);
        }else{
            $erp = $this->ErpModel->getErpList();
        }
		echo json_encode($erp);
	}
	
	public function getFilteredErpListData(){
		$data = (array) json_decode(file_get_contents("php://input"), true);
		$erp = $this->ErpModel->getFilteredErpListData($data, $this->objCurrentEmployee->company_id);
		echo json_encode($erp);
	}

	public function getColorData(){
		$data = (array) json_decode(file_get_contents("php://input"), true);
		$erp = $this->ErpModel->getColorData($data[0]);
		echo json_encode($erp);
	}

	public function addorEditErp(){
		$erp = (array) json_decode(file_get_contents("php://input"), true);		
		$data=$erp['itemRows'];
		unset($erp['itemRows']);		
		if($erp['erp_id'] == ''){
			$po = $this->PurchaseOrderModel->getPurchaseOrderById($erp['po_number']);
			$erp['style_number'] = $po->style_id;
			$erp['buyer'] = $po->buyer_id;
			$erp['created_by'] = $this->user_id;
			$erp_id=$this->ErpModel->addNewErp($erp);
			if(  $erp_id== false ) {
				echo json_encode(0);
				return;
			}	
		}else{
			if( $this->ErpModel->updateErp($erp) == false ) {
				echo json_encode(0);
				return;
			}
			$erp_id=$erp['erp_id'];
			$this->db->where("erp",$erp['erp_id']);
    		$this->db->delete("erp_colors");
		}
		for($i=0;$i<sizeof($data);$i++){
			$insert_data=array(
				'color_code' => $data[$i]['color_code'],
				'color' => $data[$i]['color'],
				'quantity' => $data[$i]['color_quantity'],
				'erp' => $erp_id,
				'created_by'=>$this->user_id
			);
			 $this->db->insert('erp_colors', $insert_data);
		}
		
		echo json_encode(1);
	}

	public function getErpInformaton(){
		$erp = (array) json_decode(file_get_contents("php://input"), true);
		$erp_data = $this->ErpModel->getErpById($erp['erp_id']);
		echo json_encode($erp_data);
	}
	
	public function getAutoGeneratedErpNumber(){
		$erp = $this->ErpModel->getLatestErpNumber();
		if($erp->erp_title){
			$s = explode('-', $erp->erp_title);
			$num = $s[1] + 1;
			$erp_number = strtoupper( substr( date('F'), 0, 3 ) ).''.date("y").'-'.str_pad($num, 6, '0', STR_PAD_LEFT);
		}else{
			$erp_number = strtoupper( substr( date('F'), 0, 3 ) ).''.date("y").'-'.str_pad(1, 6, '0', STR_PAD_LEFT);
		}
		
		echo json_encode($erp_number);
		
	}
	/************************ Erp Delivery Schedules ************************************/
	public function addorUpdateDeliverySchedule(){
		$delivery_schedule = (array) json_decode(file_get_contents("php://input"), true);
		if(!isset($delivery_schedule['id']) ){
			$delivery_schedule['created_by'] = $this->user_id;
			if( $this->ErpModel->addDeliverySchedule($delivery_schedule) == false ) {
				echo json_encode(0);
				return;
			}
		}else{
			$data = (array) json_decode(file_get_contents("php://input"), true);
			if( $this->ErpModel->updateDeliverySchedule($data) == false ) {
				echo json_encode(0);
				return;
			}
	
		}
		echo json_encode(1);
	}

	public function getDeliverySchedules(){
		$erp = (array) json_decode(file_get_contents("php://input"), true);
		$delivery_schedules = $this->ErpModel->getDeliverySchedulesByErpId($erp['erp_id']);
		echo json_encode($delivery_schedules);
	}
	
	/************************ Erp Top Material Requirements ************************************/
	public function addorEditTopMaterialRequirement(){
		$material = (array) json_decode(file_get_contents("php://input"), true);
		$req = [];

		$req['color'] = $material['color'];
		$req['color_code'] = $material['color_code'];
		$req['erp_id'] = $material['erp_id'];
		$req['created_by'] = $this->user_id;

		if($material['sizing_type'] == 0){
			$start_range = $material['range']['start'];
			$end_range = $material['range']['end'];
			$t = [];
			for($i=$start_range; $i<=$end_range;$i++){
				$key = 'size'.$i;
				$value = $material['sizes'][$key];
				$t[$key] = $value;
			}
			$req['top_requirement'] = json_encode($t);
		}else{
			$req['top_requirement'] = json_encode([
				'xs'=>$material['sizes']['xs'],
				's'=>$material['sizes']['s'],
				'm'=>$material['sizes']['m'],
				'l'=>$material['sizes']['l'],
				'xl'=>$material['sizes']['xl'],
				'xxl'=>$material['sizes']['xxl'],
				'xxxl'=>$material['sizes']['xxxl']
			]);
		}
		
		if($material['id']!=''){
			$req['id'] = $material['id'];
			if( $this->ErpModel->updateMaterialRequirement($req) == false ) {
				echo json_encode(0);
				return;
			}
		}else{
			if( $this->ErpModel->addMaterialRequirement($req) == false ) {
				echo json_encode(0);
				return;
			}
		}		
		echo json_encode(1);
	}
	
	public function getTopMaterialRequirements(){
		$erp = (array) json_decode(file_get_contents("php://input"), true);
		$top_requirements = $this->ErpModel->getMaterialRequirements($erp['erp_id'], 'top');
		$requirements = [];

		foreach($top_requirements as $t){
			$res = $t;
			$res->top_requirements = (array) json_decode($t->top_requirement);
			$requirements[] = $res; 
		}
		echo json_encode($top_requirements);
	}

	/************************ Erp Bottom Material Requirements ************************************/
	public function addorEditBottomMaterialRequirement(){
		$material = (array) json_decode(file_get_contents("php://input"), true);
		$req = [];
		$req['color'] = $material['color'];
		$req['color_code'] = $material['color_code'];
		$req['erp_id'] = $material['erp_id'];
		$req['created_by'] = $this->user_id;

		if($material['sizing_type'] == 0){
			$start_range = $material['range']['start'];
			$end_range = $material['range']['end'];
			$t = [];
			for($i=$start_range; $i<=$end_range;$i++){
				$key = 'size'.$i;
				$value = $material['sizes'][$key];
				$t[$key] = $value;
			}
			$req['bottom_requirement'] = json_encode($t);
		}else{
			$req['bottom_requirement'] = json_encode([
				'xs'=>$material['sizes']['xs'],
				's'=>$material['sizes']['s'],
				'm'=>$material['sizes']['m'],
				'l'=>$material['sizes']['l'],
				'xl'=>$material['sizes']['xl'],
				'xxl'=>$material['sizes']['xxl'],
				'xxxl'=>$material['sizes']['xxxl']
			]);
		}

		if($material['id']!=''){
			$req['id'] = $material['id'];
			if( $this->ErpModel->updateMaterialRequirement($req) == false ) {
				echo json_encode(0);
				return;
			}
		}else{
			if( $this->ErpModel->addMaterialRequirement($req) == false ) {
				echo json_encode(0);
				return;
			}
		}
		
		echo json_encode(1);
	}

	public function getBottomMaterialRequirements(){
		$erp = (array) json_decode(file_get_contents("php://input"), true);
		$top_requirements = $this->ErpModel->getMaterialRequirements($erp['erp_id'], 'bottom');
		$requirements = [];
		foreach($top_requirements as $t){
			$res = $t;
			$res->bottom_requirements = (array) json_decode($t->bottom_requirement);
			$requirements[] = $res; 
		}
		echo json_encode($requirements);
	}

	/************************ Erp Trim / Fabric Requirements ************************************/
	public function getTrimRequirements(){
		$req = (array) json_decode(file_get_contents("php://input"), true);
		$requirements = $this->ErpModel->getRequirementsByErpIdByRequiremenType($req['erp_id'], 'trim');
		echo json_encode($requirements);
	}

	public function getFabricRequirements(){
		$req = (array) json_decode(file_get_contents("php://input"), true);
		$requirements = $this->ErpModel->getRequirementsByErpIdByRequiremenType($req['erp_id'], 'fabric');
		echo json_encode($requirements);
	}

	public function addorUpdateRequirementLog(){
		$req = (array) json_decode(file_get_contents("php://input"), true);
		if($req['requirement_id']!=''){
			if( $this->ErpModel->updateTrimFabricRequirementData($req) == false ) {
				echo json_encode(0);
				return;
			}
		}else{
			$req['created_by'] = $this->user_id;
			if( $this->ErpModel->addTrimFabricRequirementData($req) == false ) {
				echo json_encode(0);
				return;
			}
		}
		
		echo json_encode(1);
	}


	/******************************Other Functions******************************************/
	public function getLoggedInUser(){
		$user_token = $this->authorization_token->validateToken();
		if($user_token['status'] == false){
			echo json_encode(0);
			return;
		}

		$this->user_id = $user_token['data']->id;
		$this->role = $user_token['data']->role;

		$this->objCurrentEmployee = $this->EmployeeModel->getEmployeeByUserId($this->user_id);

	}
}